unit QuickIntroDemoUnit;


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, yapi, ExtCtrls, Db, DBTables,printers;

type
  TForm1 = class(TForm)
    TextMemo: TMemo;
    Button1: TButton;
    Paper: TyapiPaper;
    Title: TyapiText;
    Heading: TyapiText;
    Body: TyapiText;
    tenPt: TyapiText;
    Fixed: TyapiText;
    PrintDialog: TPrintDialog;
    SourceMemo: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
    lineindex:Integer;
    procedure PutText;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.PutText;
{ this procedure puts text from the TextMemo component
 (which has the textual content of the report) on to yapi.
 It operates with a simple markup language
}
var s:string;
i:Integer;
mark:char;
begin
  with textmemo do begin
     i:=lines.count;
     while lineindex<i do begin
        s:=lines[lineindex];
        if (length(s)>1) and (s[1]='-') then begin
           mark:=lines[lineindex][2];
           case mark of
              'H' : // Print a sub heading line
                       Heading.writeln(pchar(s)+3);
              'S' : begin
                       // exit with linindex pointing to the next line
                       inc(lineindex);
                       exit;
                    end;
              'P' : begin
                      paper.newpage;
                    end;

           end;
        end else begin
           body.writeln(lines[lineindex]);
        end;
        inc(lineindex);
     end;
  end;
end;


procedure TForm1.Button1Click(Sender: TObject);
// this is the button that does all the printing
var
i:Integer;
begin
   paper.clear;
   lineindex:=0;
   title.writecentre('Yapi',0);     // page title
   title.writeln;                   // do some vertical spacing with empty writeln
   title.writeln;                   // spacing
   title.writeln;                   // spacing
   puttext;                         // place text from the TextMemo onto the printer
   title.writeln;                   // spacing
   for i:=0 to sourcememo.lines.count-1 do // put in the paper using a fixed font
     fixed.writeln(sourcememo.lines[i]);
   paper.preview;                   // Print preview and printing
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  textmemo.visible:=false;
  sourcememo.visible:=false;
end;

end.
